unit zcgi;
// **************    CGI **********
//   z_ol.chat.ru

interface
uses Classes, Windows, Sysutils;
 type
   // ,   
 TCGIParamsParser = class
  private
    FParamStr: string;
    procedure SetParamStr(const Value: string);
    protected
     FParamList : TStrings;
    public
     Constructor Create;  // 
     Destructor  Destroy; // 
     //    
     Function    GetParamVal(AName : string;DefVal : string = ''): string;
    published
     //  
     Property ParamStr: string read FParamStr write SetParamStr;
   end;
 //      
 Function GetEnv(AName : string) : String;
 //  
 Function DecodeParam(AParam : string) : String;
implementation

//      
Function GetEnv(AName : string) : String;
var
 Buf : array[0..16000] of char;
begin
 GetEnvironmentVariableA(PChar(AName), Buf, SizeOf(buf));
 Result := Buf;
end;

//  
Function DecodeParam(AParam : string) : String;
var
 i : integer;
begin
 Result := '';
 if AParam = '' then exit;
 i := 1;
 while i <= Length(AParam) do
  case AParam[i] of
   '+' : begin
          Result := Result + ' ';
          inc(i);
         end;
   '%' : begin
          try
           Result := Result + Chr(StrToInt('$'+Copy(AParam,i+1,2)));
          except end;
          inc(i, 3); //  % +    
         end;
   else begin
          Result := Result + AParam[i];
          inc(i);
         end;
  end;
end;

{ *************** TCGIParamsParser ******************** }
// 
constructor TCGIParamsParser.Create;
begin
 FParamList := TStringList.Create;
end;

// 
Destructor  TCGIParamsParser.Destroy;
begin
 FParamList.Free;
end;

//   ,    
procedure TCGIParamsParser.SetParamStr(const Value: string);
var
 s, st : string;
begin
  FParamList.Clear;
  FParamStr := Value;
  s := FParamStr+'&';
  while pos('&', s) > 0 do begin
   st := Copy(s, 1, pos('&', s)-1);
   Delete(s, 1, pos('&', s));
   if Trim(st) <> '' then
    FParamList.Add(DecodeParam(Trim(st)));
  end;
end;

//   
function TCGIParamsParser.GetParamVal(AName: string;DefVal : string = ''): string;
begin
 Result := FParamList.Values[AName];
 if Result = '' then
  Result := DefVal;
end;
end.